
package de.ivu.elect.presentation.wahlvorschlag;

import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.wahlvorschlag.boundary.ReferendumOptionConversationStore;
import de.ivu.elect.business.wahlvorschlag.boundary.ReferendumOptionExtendedDAO;
import de.ivu.elect.business.wahlvorschlag.boundary.ReferendumOptionEdit;
import de.ivu.elect.business.wahlvorschlag.entity.ReferendumOption;
import de.ivu.elect.business.wahlvorschlag.entity.ReferendumOptionMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.presentation.View;
import de.ivu.elect.jee.presentation.redirect.Redirect;

@Named(AbstractReferendumOptionEditNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractReferendumOptionEditNoScopeView.VIEW_ID, useCase = UseCasePermission.REFERENDUM_OPTION_EDIT)
public abstract class AbstractReferendumOptionEditNoScopeView extends de.ivu.elect.presentation.AbstractElectEditView<ReferendumOption>  {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "referendumOptionEditView";

  public static final String VIEW_ID = "/wahlvorschlag/referendum-option-edit.xhtml";

  public static final String PARENT_VIEW_ID = "/wahlvorschlag/referendum-option-search.xhtml";

  @Inject
  protected transient ReferendumOptionExtendedDAO extendedDAO;

  @Inject
  protected transient ReferendumOptionEdit edit;

  @Inject
  @ConversationGroup(ReferendumOptionConversationStore.class)
  protected transient ReferendumOptionConversationStore conversationStore;

  @Inject
  protected transient ReferendumOptionMeta entityMeta;

  @Inject
  // ELECTDD-204 Auf doppelte Bearbeitung von Entitäten Hinweisen
  protected transient ReferendumOptionEditViewScopeStore entityViewStore;

  @de.ivu.elect.jee.faces.PreConditionCheck
  public String checkPreCondition() {
    if (getEntity() == null) {
      return getParentViewId();
    }
    return null;
  }

  @Override
  public ReferendumOption getEntity() {
    if (conversationStore.getEntityPK() != null) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }
    return null;
  }

  public void setEntity(ReferendumOption entity) {
    resetModel(); // DynaForm-Model zurücksetzen, damit die aktuelle Entität verwendte wird...
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  public boolean isEntitySet() {
    return conversationStore.getEntityPK() != null;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.REFERENDUM_OPTION_DELETE)
  @Override
  public String delete() {
    return delete(getEntity());
  }

  protected String delete(ReferendumOption entity) {
    edit.delete(entity);

    addMessageDeleteSuccess();

    resetStateAfterAction();
    return getParentViewId(); // definierter Parent, benutze deleteAndGoBack um zum vorherigen View zurückzukehren
  }



  @Redirect
  @UseCaseSecure(UseCasePermission.REFERENDUM_OPTION_DELETE)
  public String deleteAndGoBack() {
    delete();
    return goBack(getParentViewId());
  }

  protected void addMessageDeleteSuccess() {
    addInfoMessage("entity.edit.action.delete.success.message", entityMeta.getEinzahlMessage());
  }

  public boolean isBtnDeleteRendered() {
    return hasPermission(UseCasePermission.REFERENDUM_OPTION_DELETE);
  }

  @Redirect
  @Override
  public String cancel() {
    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  @Override
  public boolean isBtnCancelRendered() {
    return true;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.REFERENDUM_OPTION_EDIT)
  @Override
  public String save() {
    ReferendumOption entity = getEntity();

    callSave(entity);

    addMessageSaveSuccess(entity);

    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  protected void callSave(ReferendumOption entity) {
    edit.save(entity);
  }

  @Redirect
  @Override
  public String reset() {
    super.reset();
    ReferendumOption entity = getEntity();
    resetStateAfterAction();
    setEntity(entity);
    return getViewId();
  }

  protected void addMessageSaveSuccess(ReferendumOption entity) {
    addInfoMessage("entity.edit.action.save.success.message", entityMeta.getEinzahlMessage());
  }

  @Override
  protected boolean isSavePermissionVorhanden() {
    return hasPermission(UseCasePermission.REFERENDUM_OPTION_EDIT);
  }
  
  @Redirect
  public String edit(ReferendumOption entity) {
    conversationStore.setEntityPK(entity.getPk());
    return getViewId();
  }

  protected String getViewId() {
    return VIEW_ID;
  }

  protected String getParentViewId() {
    return PARENT_VIEW_ID;
  }

  protected void resetStateAfterAction() {
    conversationStore.close();
  }

  @de.ivu.elect.jee.faces.PreConditionCheck
  public void checkDoppelteBearbeitung() {
     entityViewStore.setEntity(getEntity());
  }

  @org.apache.deltaspike.core.api.scope.ViewAccessScoped
  public static class ReferendumOptionEditViewScopeStore extends  de.ivu.elect.presentation.edit.AbstractViewScopeStore<ReferendumOption,  de.ivu.elect.business.wahlvorschlag.entity.WahlvorschlagPK  > {

    private static final long serialVersionUID = 1L;
  }
}
